*-09sep2020
*-Autor: zarlu@hotmail.com
*-Agregar de Excel a un cursor temporal de VFP (APPEND FROM ...)
*-No requiere guardar previo el Excel como "Libro de Microsoft Excel 5.0/95(*.xls)"

*-17sep2020
*-Opcin de tomar primer renglon como nombres de campos
*-Ajusta ancho de campos a contenido de registros
*-Toma informacin de hasta a partir del renglon y/o columna 45 de Excel

*-Enumeracin XlFileFormat (Excel):
*-https://docs.microsoft.com/es-es/office/vba/api/excel.xlfileformat

CLEAR

*-nombre del cursor a crear
lcCursor=ALLTRIM(Inputbox( "Nombre del cursor temporal a crear:",;
	"Agregar a cursor desde Excel", "" ))
	lcCursor=STRTRAN(lcCursor," ","_")
IF EMPTY(lcCursor)
	RETURN
EndIF	

*-selecciona archivo excel
lcFile=GETFILE('xls*', 'Leer Archivo:', 'Abrir',0, 'Mostrar Archivos de Excel')
If Empty(lcFile) .or. !FILE(lcFile)
    Messageb("No seleccion archivo  no existe.",0+48,"Verifique")
    Return
EndIf

*-inicia excel
loExcel = CREATEOBJECT("Excel.Application")

WITH loExcel

*-abre archivo excel
.Workbooks.Open(lcFile)
.Application.DisplayAlerts = .f.

*elimina columnas y renglones vacios. 45
lcMensaje="Revisando primeras columnas yrenglones ....."
Wait lcMensaje Windows At Int(10),Int(_Screen.Width/2-Len(lcMensaje)/2)+25 Nowait Noclear
lcNull=.T.
FOR lcPriRow=1 TO 45&&rows
	lcNoDat=.T.
	FOR lcPriCol=1 TO 45&&columnas
		IF !ISNULL(.Cells(lcPriRow,lcPriCol).VALUE)
			lcNull=.f.
			lcNoDat=.F.
			EXIT
		EndIF	
	ENDFOR
	IF lcNoDat=.F.
		*-elimina rows
		FOR nl = lcPriRow-1 to 1 step -1
			x=Alltr(Str(nl)) 
			.Rows(&x.).Delete 
		ENDFOR
		*-elimina columnas
		FOR nl = lcPriCol-1 to 1 step -1
			x=Alltr(Str(nl)) 
			.Columns(&x.).Delete 
		ENDFOR
	ENDIF
EndFor	
WAIT Clear

IF lcNULL=.T.
	*-excel vacio
   	MESSAGEBOX("Archivo Excel Vaco.",0,"Verifique")
ELSE
	*-cuenta columnas excel
	lcCols=.activesheet.usedrange.columns.count	
	*lcRows=.activesheet.usedrange.rows.count

	*guarda excel como 5.0/95 	
	lcArchivo = GetEnv("TEMP") + "\tempovfp" + Sys(2015) + ".xls"
	.application.activeworkbook.saveas(lcArchivo,39)
ENDIF

*cierra excel
.application.activeworkbook.close
.application.quit 	
RELEASE loExcel

ENDWITH

*cancela rutina
IF lcNULL=.T.
	Return
ENDIF

*pregunta nombres de campos
lcCampos=.T.&&tomar primera linea como nombres de campos
IF MESSAGEBOX("Tomar primer rengln como nombre de campos?",4+32,"Confirme" )=7
	lcCampos=.F.
EndIF

*-crear cursor
CREATE CURSOR (lcCursor) (campo1 C(254))
FOR lcCrear=2 TO lcCols
	ALTER TABLE (lcCursor) ADD COLUMN ("campo"+ALLTRIM(STR(lcCrear))) C(254)
ENDFOR

*-agrega datos de excel
APPEND FROM &lcArchivo TYPE XLS

*-elimina archivo temporal de excel
DELETE FILE (lcArchivo)

*nombres de campos
IF lcCampos=.t.
	GO Top
	lcCadena=""&&para nombres repetidos
	FOR lcField=1 TO FCOUNT()
		lcNew=FIELD(lcField)
		lcNew=Upper(ALLTRIM(&lcNew))
		lcNew=IIF(LEFT(lcNew,1) $ "1234567890","_"+lcNew,lcNew)
		IF !EMPTY(lcNew)
			*limpia caracteres
			lcLimpio=""
			FOR u=1 TO LEN(lcNew)
				*A-Z  "_"
				IF (ASC(SUBSTR(lcNew,u,1))>=65 .and. ASC(SUBSTR(lcNew,u,1))<=90) .or.;
					(ASC(SUBSTR(lcNew,u,1))>=48 .and. ASC(SUBSTR(lcNew,u,1))<=57) .or.;
					ASC(SUBSTR(lcNew,u,1))=95
					lcLimpio=lcLimpio+SUBSTR(lcNew,u,1)
				ELSE
					lcLimpio=lcLimpio+""
				EndIF
			ENDFOR
			lcNew=lcLimpio

			*nombres repetidos
			lcRepet=lcNew
			lcExt=1
			DO WHILE .t.
				IF !"#"+lcRepet+"#" $ lcCadena
					lcCadena=lcCadena+"#"+lcRepet+"#"
					Exit
				ELSE
					lcRepet=lcNew+"_"+ALLTRIM(STR(lcExt))
				ENDIF
				lcExt=lcExt+1
			ENDDO
		ENDIF
		
		lcNew=lcRepet

		*-cambia nombres de campos
		TRY
			ALTER TABLE (lcCursor) RENAME COLUMN (FIELD(lcField)) TO &lcNew
		    CATCH TO loErr
		    Finally
		ENDTRY
	ENDFOR
	
	*elimina primer registro. nombres de campos
	SET DELETED ON
	GO top
	Delete
ENDIF

*-ajusta ancho de campos
FOR lcField=1 TO FCOUNT()
	lcName=FIELD(lcField)
	lcLen=LEN(FIELD(lcField))
	FOR lcL=254 TO lcLen STEP -1
		LOCATE FOR LEN(AlLtrim(&lcName))=lcL
		IF FOUND()
			EXIT
		EndIF
	ENDFOR
	lcMax=MAX(lcLen,LEN(AlLtrim(&lcName)))
	lcMax=IIF(lcMax<10,10,lcMax)
	ALTER TABLE (lcCursor) ALTER COLUMN (lcName) c(lcMax)
ENDFOR

BROWSE
USE
RETURN
*-Fin